{  This file is part of Gum_Mc, uncertainty calculation software
    Copyright (C) 2010  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
 Gum_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}

unit Unit1;

{$mode objfpc}{$H+} {$R-}

interface

uses
  Classes, charencstreams, SysUtils, FileUtil, TAGraph, TASources, TASeries,LazUTF8,
  LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Grids,
  ComCtrls, Buttons, Menus, Symbolic, unit_type_evaluation,
  Unit_genere_distribution, Unit_incertitude_trop_grande, UTF8Process, LazFileUtils ,
  unit_dois_je_calculer, Math,
  Unitsaisiemontecarlo, Unit_trace, SpecFunx, Unit_aidecalcul, UnitGPL, Unit4,unit_saisie_estimateur,LCLType, UnitScaleFont, LCLIntf ,LazHelpHTML, UChaines,unit_descriptif, gettext, translations, clipbrd
  ,Amath,Unit_affichage_valeur_individuelle,Unit_affichage_incertitude
  {$ifdef windows},windows,shellapi,registry{$endif},unit_saisie_type_b,unit_saisie_type_a;




type
      TExtRec  = packed record     {Extended as sign, exponent, significand}
               lm: longint;    {low  32 bit of significand}
               hm: longint;    {high 32 bit of significand}
               xp: word;       {biased exponent and sign  }
             end;


  { TForm1 }

  TForm1 = class(TForm)


    BitBtn_comparer_reference: TBitBtn;
    BitBtn_charger_depuis_autre: TBitBtn;
    BitBtn_charger_depuis_exemples: TBitBtn;
    BitBtn_charger_depuis_personnel: TBitBtn;
    Chart1: TChart;
    Chart1BarSeries1: TBarSeries;
    Chart2: TChart;
    Chart2PieSeries1: TPieSeries;
    Edit_saisie_unite: TEdit;
    edit_nom_grandeur_sortie: TEdit;
    Edit_saisie_expression: TEdit;
       Edit_incertitude_type: TEdit;
    Edit_valeur_mesuree: TEdit;
    Edit_ecart_relatif: TEdit;
    Edit_valeur_reference: TEdit;
    ImageList1: TImageList;
    Label_incertitude_relative: TLabel;
    Label_estimateur_incertitude: TLabel;
    Label_estimateur_mesurande: TLabel;
    Label9: TLabel;
    ListChartSource1: TListChartSource;
    MainMenu1: TMainMenu;
    Memo_commentaires: TMemo;
    MenuItem1: TMenuItem;
    MenuItem_affichage_incertitude: TMenuItem;
    MenuItem_affichage_individuel: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem_arrondi_normal_inc: TMenuItem;
    MenuItem_arrondi_sup_inc: TMenuItem;
    MenuItem_arrondi_inc: TMenuItem;
    MenuItem_incertitude: TMenuItem;
    OpenDialog2: TOpenDialog;
    PageControl1: TPageControl;
    RadioGroup1: TRadioGroup;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    BitBtn_fonction_: TSpeedButton;
    BitBtn1_: TSpeedButton;
    SpeedButton5: TSpeedButton;
    StaticText1: TStaticText;
    StaticText10: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
       StaticText_unite1: TStaticText;
    StaticText_incertitude_type: TStaticText;
    StaticText_unite2: TStaticText;
    StaticText_unite3: TStaticText;
    StaticText_valeur_reference: TStaticText;
    StaticText_valeur_mesure: TStaticText;
    StaticText_facultatif: TStaticText;
    StaticText_diff_mes_ref: TStaticText;
	    StaticText_proba_comp_10: TStaticText;
    StaticText_proba_comp_2: TStaticText;
    StaticText_proba_comp_1: TStaticText;
    StaticText_proba_comp_4: TStaticText;
    StaticText_proba_comp_3: TStaticText;
    StaticText_proba_comp_5: TStaticText;
    StaticText_proba_comp_6: TStaticText;
    StaticText_proba_comp_7: TStaticText;
    StaticText_proba_comp_8: TStaticText;
    StaticText_proba_comp_9: TStaticText;
    StringGrid1: TStringGrid;
    StringGrid_entree: TStringGrid;
    StringGrid4: TStringGrid;
    TabSheetcomparaison: TTabSheet;
    TabSheet_commentaires: TTabSheet;
    TabSheet_expression: TTabSheet;
    TabSheet_entree: TTabSheet;
    TabSheet_resultats: TTabSheet;
    TabSheet_bienvenue: TTabSheet;
    procedure BitBtn10Click(Sender: TObject);


 procedure BitBtn_comparer_referenceClick(Sender: TObject);
    procedure BitBtn1_Click(Sender: TObject);
    procedure BitBtn_charger_depuis_autreClick(Sender: TObject);
    procedure BitBtn_charger_depuis_exemplesClick(Sender: TObject);
    procedure BitBtn_charger_depuis_personnelClick(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem_affichage_incertitudeClick(Sender: TObject);
    procedure MenuItem_affichage_individuelClick(Sender: TObject);
    procedure rafraichitstringgridentree(sender:tobject);

    procedure Actualise_Ecart_Relatif_A_Valeur_Reference(Sender: TObject);




    procedure BitBtn_fonction_Click(Sender: TObject);
    procedure Edit_saisie_expressionChange(Sender: TObject);


    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure MenuItem_arrondi_normal_incClick(Sender: TObject);
    procedure MenuItem_arrondi_sup_incClick(Sender: TObject);
    procedure Enregistrer(nom_fifichier:string;Sender: TObject);
    procedure MenuItem_enregistrerClick(Sender: TObject);
    procedure MenuItem_enregistrer_exemplesClick(Sender: TObject);
    procedure MenuItem_enregistrer_persoClick(Sender: TObject);
    procedure MenuItem_incertitudeClick(Sender: TObject);
    procedure MenuItem_montecarloClick(Sender: TObject);
    procedure MenuItem_nouveauClick(Sender: TObject);
    procedure MenuItem_ouvrir_dernierClick(Sender: TObject);
    procedure MenuItem_ouvrir_exemplesClick(Sender: TObject);
    procedure MenuItem_ouvrir_personnelClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);





    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);


    procedure RemetAZero(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);

    procedure SpeedButton7Click(Sender: TObject);


    procedure StaticText11Click(Sender: TObject);
    procedure StaticText13Click(Sender: TObject);
    procedure ChargerFichier(nom_fifichier:string;Sender: TObject);

    procedure StringGrid_entreeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid_entreeMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure StringGrid_entreePrepareCanvas(sender: TObject; aCol,
      aRow: Integer; aState: TGridDrawState);

    procedure TabSheet_entreeShow(Sender: TObject);
    procedure TabSheet_expressionShow(Sender: TObject);
    procedure TabSheet_mcShow(Sender: TObject);
    procedure TabSheet_resultatsShow(Sender: TObject);
  private
      encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end; 


  TGotoTimer = class(TTimer)
  private
    TargetGrid: TStringGrid;
    TargetCol: Integer;
    TargetRow: Integer;
    procedure GotoColRow(Sender: TObject);
  public
    constructor Create(Grid: TStringGrid; Col, Row: Integer); overload;
  end;


  type
    type_AB=(type_A,type_B);
    type_distribution=(d_normale,d_student,d_rectangle,d_triangle,d_trapeze,d_arcsin);
    type_defini_par=(par_incertitude_type,par_ecart_type_echantionnal,par_incertitude_elargie,par_demi_etendue);
    distribution=object
      tyty:type_distribution;
    tyAB:type_AB;
    nom_variable,descriptif:string;
   moyenne,incertitude_type,demi_etendue,incertitude_elargie,
     pourcentage,ecart_type_echantionnal,demi_etendue_bas,demi_etendue_haut:extended;
   degres_de_liberte:integer;
   indice_de_la_variable_correspondante:integer;
   defini_par:type_defini_par;
   inc_rel_sur_inc, degres_de_liberte_effectif:extended;
      student_nombre_mesures:integer;
   student_liste_mesures:array of extended;
    end;

    distributionarray=array of distribution;
    defini_par_array=array of type_defini_par;
    booleanarray=array of boolean;

    mesurande=object
      estimateur:extended;
      nom_mesurande,descriptif_mesurande:string;
           nombre_erreurs:integer;
           liste_des_indices_des_sources_derreur:integerarray;
      incertitude_type:extended;
    end;
    mesurandearray=array of mesurande;


var   mon_genre_affichage_incertitude:type_affichage_incertitude;
  mon_genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle;
  ma_longueur_chaine_agreable_valeur_individuelle,ma_longueur_chaine_agreable_incertitude:integer;
  echantillon_inexploitable:boolean;    parametre_ligne_commande:boolean;
  Form1: TForm1;    tous_calculs_faits:boolean;
   Liste_Variables : TStringList;
 old_chaine_expr,chaine_expr:string;
   expr_temp:texpression;
   nombre_mesurandes,nombre_distributions:integer;
   estimations,incertitudes_type:extendedarray;
   liste_mesurandes:mesurandearray;
   liste_distributions:distributionarray;
   liste_distribution_est_traitee,liste_mesurande_est_traitee:booleanarray;
     { colonne,ligne,}indice_distribution,indice_mesurande:integer;

    nombre_par_echantillon:longint;
    puissance_de_nombre_par_echantillon:longint;
    nombre_de_classes:longint;

    hauteur_image_densite,largeur_image_densite,hauteur_image_integre,largeur_image_integre:integer;
     moyenne_sortie,ecart_type_sortie,borne_inf_court_95,borne_sup_court_95,borne_inf_sym_95,borne_sup_sym_95,
     borne_inf_court_99,borne_sup_court_99,borne_inf_sym_99,borne_sup_sym_99,
     borne_inf_court_75,borne_sup_court_75,borne_inf_sym_75,borne_sup_sym_75:extended;
     Eval_f    : TEvaluator;
     eval_derivees:array of tevaluator;
     expr_derivees:array of texpression;
     eval_derivees_secondes:array of array of tevaluator;
     expr_derivees_secondes:array of array of texpression;
      eval_derivees_troisiemes:array of array of tevaluator;
     expr_derivees_troisiemes:array of array of texpression;
      repertoireexecutable:string;
     liste_echantillon_sortie,valeur_derivees:extendedarray;
     valeur_derivees_secondes:array of array of extended;

      valeur_derivees_troisiemes:array of array of extended;

    contributions_croisees:array of array of extended;
chance_que_lecart_soit_superieur_normal,chance_que_lecart_soit_superieur_student:extended;
     estimateur_sortie,incertitude_type_sortie,degre_effectif_global:extended;
     expression_validee:boolean;
      coef_elarg_95_normale,coef_elarg_99_normale,coef_elarg_75_normale,
coef_elarg_95_student,coef_elarg_99_student,coef_elarg_75_student:extended;
 symbole_grandeur_sortie,symbole_unite:string;

 option_tronque_a_zero_quand_incertitude_trop_grande:boolean;
   option_arrondi_superieur_incertitude:boolean;
      valeur_reference,comparaison_relative:extended;

   repertoire_executable,repertoire_images,nomexecutable,repertoire_exemples:string;
   repertoire_aide,repertoire_config_perso,repertoire_propagation_perso:string;
    lang,FallbackLang,nom_ini_file,chemin_po,nom_fichier_sauvegarde:string;
    liste_langues:tstringlist;

     Search:sysutils.TSearchRec;
        ID_lang:string;   nom_fichier_chargement,
        dernier_repertoire_utilise_chargement,dernier_repertoire_utilise_sauvegarde,PODirectory: String;
          f_ini:textfile;




     function isnanorinfinite(x:float):boolean;
         function superstrtofloat(s:string):extended;
  procedure CopyStringGridToClipboard(st:tstringgrid);
  function myfloattostr(x:extended):string;
  function mystrtofloat(s:string):extended;
  function isligne_distribution(row:integer; var indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer):boolean;

  function isligne_mesurande(row:integer; var indice_variable_pour_ajout_source_erreur_a_debut_zero:integer):boolean;
var i,li:integer;

           procedure Effacer_Element_Tableau_Distributions(var A: distributionArray; const Index: Cardinal);
            procedure Effacer_Element_Tableau_Reel(var A: extendedArray; const Index: Cardinal);
          function isligne_intercalaire(row:integer):boolean;
implementation

label 1888;

  procedure TGotoTimer.GotoColRow(Sender: TObject);
begin
  Enabled := False;
  TargetGrid.SetFocus;
  TargetGrid.Col := TargetCol;
  TargetGrid.Row := TargetRow;
  TargetGrid.EditorMode := True;
  Form1.RemoveComponent(Self);
end;

constructor TGotoTimer.Create(Grid: TStringGrid; Col, Row: Integer);
begin
  inherited Create(Form1);
  TargetGrid := Grid;
  TargetCol := Col;
  TargetRow := Row;
  OnTimer := @GotoColRow;
  Interval := 20;
end;



  function superstrtofloat(s:string):extended;
  var L_V : TStringList;
          E_T:texpression;
          E_F:TEvaluator;
          V    : Array OF ArbFloat;
          z:extended;
  begin
  try
          E_T:=TExpression.Create(s);
   except
        z:=strtofloat('a');
      exit;
         end;

     L_V:=E_T.SymbolicValueNames;
     if L_V.Count<>0 then begin
     z:=strtofloat('a');
     exit;
     end;

      E_F:=TEvaluator.Create(L_V,E_T);
      setlength(V,0);

   try
   z:=E_F.Evaluate(V);


   finally
     if isnanorinfinite(z) then z:=strtofloat('a');
     result:=z;
   end;
  end;
          procedure Effacer_Element_Tableau_Reel(var A: extendedArray; const Index: Cardinal);
           var
                  ALength: Cardinal;
                   TailElements: Cardinal;
                 begin
                    ALength := Length(A);
                    if ALength=0 then exit;
                     if Index>=ALength then exit;
                     if Index<0 then exit;
                     Finalize(A[Index]);
                      TailElements := ALength - Index-1;
                      if TailElements > 0 then
                        Move(A[Index + 1], A[Index], SizeOf(float) * TailElements);
                       Initialize(A[ALength - 1]);
                       SetLength(A, ALength - 1);
                   end;

     procedure Effacer_Element_Tableau_Distributions(var A: distributionArray; const Index: Cardinal);
           var
                  ALength: Cardinal;
                   TailElements: Cardinal;
                 begin
                    ALength := Length(A);
                    if ALength=0 then exit;
                     if Index>=ALength then exit;
                     if Index<0 then exit;
                     Finalize(A[Index]);
                      TailElements := ALength - Index-1;
                      if TailElements > 0 then
                        Move(A[Index + 1], A[Index], SizeOf(distribution) * TailElements);
                       Initialize(A[ALength - 1]);
                       SetLength(A, ALength - 1);
                   end;





   function myfloattostr(x:extended):string;
   begin
   if not(isnanorinfinite(x)) then result:=(floattostr(x)) else
      result:=('NAN');



   end;

  function mystrtofloat(s:string):extended;
   begin
   if upcase(s)<>'NAN' then result:=strtofloat(s) else
      result:=NAN;
   end;

procedure CopyStringGridToClipboard(st:tstringgrid);
  var
  i, j : integer;
  text : string;
begin
  for i:= 0 to (st.RowCount - 1) do   //Pour chaque ligne
  begin
    for j := 0 to (st.ColCount - 1) do   //Pour chaque colonne
    begin
      if j < (st.ColCount - 1) then   //si pas dernière colonne
        text := text + st.Cells[j,i] + #9   //ajoute contenu de la cellule + une tabulation (cellule suivante)
      else
        text := text + st.Cells[j,i];  //ajoute juste le contenu de la cellule
    end;
    text := text + lineending;  //Ajoute un saut de ligne
  end;
  Clipboard.AsText := Text;   //copie dans le presse papier les informations
  end;




Function MyGetAppConfigDirUTF8: String;
{il est necessaire de modifier GetAppConfigDir acr sur les systemes
windows renvoie local setting\application data au lieu de application data}
var
  I: Integer;
  EnvVars: TStringList;
begin
{$ifndef windows}
result:=systoutf8(SysUtils.GetAppConfigDir(false));
{$endif}
 {$ifdef windows}
  EnvVars := TStringList.Create;
try
       for I := 0 to GetEnvironmentVariableCount - 1 do
      EnvVars.Add(GetEnvironmentString(I));
        result:=systoutf8(AppendPathDelim(EnvVars.Values['APPDATA'])+'gum_mc_eleve_lycee\');

  finally
    EnvVars.Free;
  end;
  {$endif}
end;



Function ExpandEnvironmentString(s: String): String;
    Var i, k: Integer;
        sl: TStringList;
        s2: String;
        bP, bD: Boolean;
    Begin
      Result := s;
      bP := Pos('%', s) > 0;
      bD := Pos('$', s) > 0;
      If Not(bP Or bD) Then Exit; // Nichts zu konvertieren
      sl := TStringList.Create;
      sl.Sorted := bD;
      For i := GetEnvironmentVariableCount - 1 DownTo 0 Do // Alle Variablen in eine Liste merken
      Begin
        s2 := GetEnvironmentStringUTF8(i);
        If Length(s2) >= 2 Then
          If s2[1] <> '=' Then // Bei Windows kommt sowas auch vor, daher wegoptimieren
            sl.Add(s2);
      end;

      k := 0;
      Repeat // Durchlaufe so oft bis alle Env-Variablen aufgelöst sind
        s2 := Result;
        For i := sl.Count - 1 DownTo 0 Do
        Begin
          If bP Then
          Begin
            Result := StringReplace(Result, '%' + sl.Names[i] + '%', sl.ValueFromIndex[i], [rfReplaceAll, rfIgnoreCase]);
            If Pos('%', Result) = 0 Then bP := False;
          end;
          If bD Then
          Begin
            Result := StringReplace(Result, '$' + sl.Names[i], sl.ValueFromIndex[i], [rfReplaceAll]);
            If Pos('$', Result) = 0 Then bD := False;
          end;
          If Not(bP Or bD) Then Break;
        end;
        If Not(bP Or bD) Then Break;
        If SameText(s2, Result) Then Break; // % $ nicht konvertierbar, da im System nicht vorhanden
        Inc(k);
        If k > sl.Count - 2 Then Break; // Max Durchläufe
      Until True;
      sl.Free;
    end;




{$ifdef windows}
Function MyGetMesDocumentsUTF8: String;
var
    Reg: TRegistry;

begin

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\'
      + 'Explorer\User Shell Folders\', False);
    result:=ExpandEnvironmentString(Reg.ReadString('Personal'));
  finally
    Reg.Free;

  end;
    end;
     {$endif}



function MyIsnan(x: float): boolean;
  {-Return true if x is a NaN}
begin
  with TExtRec(x) do begin
    MyIsnan := (xp and $7FFF=$7FFF) and ((hm<>longint($80000000)) or (lm<>0));
  end;
end;



function isnanorinfinite(x:float):boolean;
 begin
 result:=(myisnan(x) or isinfinite(x));
 end;




{ TForm1 }

procedure TForm1.FormResize(Sender: TObject);
begin

end;

procedure TForm1.Actualise_Ecart_Relatif_A_Valeur_Reference(Sender: TObject);
 begin
  Edit_valeur_mesuree.Text:=floattostr(estimateur_sortie);
  Edit_incertitude_type.Text:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
  StaticText_unite1.Caption:=symbole_unite;
  StaticText_unite2.Caption:=symbole_unite;
  StaticText_unite3.Caption:=symbole_unite;
   try
    valeur_reference:=superstrtofloat(Edit_valeur_reference.Text);
    except
      application.MessageBox(pchar(rsValeurDeRFRe), pchar( rsAttention2), mb_ok
        );
      Edit_ecart_relatif.TEXT:='';
      exit;
      end;
   Edit_valeur_reference.Text:=floattostr(valeur_reference);

   if (incertitude_type_sortie=0) then begin
    Edit_ecart_relatif.text:=rsInfini;
    exit;
   end;
   if isinfinite(incertitude_type_sortie) then begin
    comparaison_relative:=0;
     Edit_ecart_relatif.text:='0';
      exit;
   end;
   if myisnan(incertitude_type_sortie) then begin
    comparaison_relative:=0;
     Edit_ecart_relatif.text:='NAN';
      exit;
   end;

   comparaison_relative:=abs(valeur_reference-estimateur_sortie)/incertitude_type_sortie;
  Edit_ecart_relatif.text:=Donne_Avec_Chiffres_Significatifs(comparaison_relative,2,_sans_puissance_de_dix,ma_longueur_chaine_agreable_valeur_individuelle);
  
  StaticText_proba_comp_3.Caption:=Donne_Avec_Chiffres_Significatifs(comparaison_relative,3,_sans_puissance_de_dix,ma_longueur_chaine_agreable_valeur_individuelle);

 chance_que_lecart_soit_superieur_normal:=200*(1-normstd_cdfx(comparaison_relative));
 StaticText_proba_comp_5.Caption:=Donne_Avec_Chiffres_Significatifs(chance_que_lecart_soit_superieur_normal,3,_sans_puissance_de_dix,ma_longueur_chaine_agreable_valeur_individuelle)+'%';

 StaticText_proba_comp_8.Caption:=Donne_Avec_Chiffres_Significatifs(comparaison_relative,3,_sans_puissance_de_dix,ma_longueur_chaine_agreable_valeur_individuelle);

  if ((degre_effectif_global>0) and (degre_effectif_global<1000)) then  begin
        try
    chance_que_lecart_soit_superieur_student:=200*(1-t_cdfx(floor(degre_effectif_global),comparaison_relative));
       except
        chance_que_lecart_soit_superieur_student:=200*(1-normstd_cdfx(comparaison_relative));
       end;
   end  else  chance_que_lecart_soit_superieur_student:=200*(1-normstd_cdfx(comparaison_relative));
 StaticText_proba_comp_10.Caption:=Donne_Avec_Chiffres_Significatifs(chance_que_lecart_soit_superieur_student,3,_sans_puissance_de_dix,ma_longueur_chaine_agreable_valeur_individuelle)+'%';

 
 
         end;

procedure TForm1.BitBtn_comparer_referenceClick(Sender: TObject);
 begin
  Actualise_Ecart_Relatif_A_Valeur_Reference(Sender);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // if encreation then begin scalefont(self); encreation:=false; end;
end;

procedure TForm1.Label1Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem13Click(Sender: TObject);
label 1111;
begin
  if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

  1111:
  savedialog1.InitialDir:=dernier_repertoire_utilise_sauvegarde;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
      savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;

    if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi, [nom_fichier_sauvegarde
   ])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


  if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
  Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  formgpl:=tformgpl.create(self);
 with formgpl
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
//formgpl.Memogpl.Clear;
//formgpl.Memogpl.Lines.LoadFromFile(UTF8ToSys(repertoireexecutable+'gpl.txt'));
formgpl.ShowModal;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  with form4
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form4.showmodal;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:='http://jeanmarie.biansan.free.fr/logiciel.html';
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end; end;

procedure TForm1.MenuItem9Click(Sender: TObject);
var n:integer; f:textfile;
begin
n:=(Sender as TComponent).Tag;
if n<=1000 then exit;
if liste_langues[n-1000-1]=fallbacklang then exit;

application.MessageBox(pchar(rsPourPrendreE), pchar(rsChangementDe), mb_ok);


               assignfile(f,UTF8ToSys(nom_ini_file));
        rewrite(f);
        writeln(f,liste_langues[n-1000-1]+'_'+uppercase(liste_langues[n-1000-1]));
               writeln(f,liste_langues[n-1000-1]);
        closefile(f);

 application.Terminate;
end;

procedure TForm1.MenuItem_arrondi_normal_incClick(Sender: TObject);
begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=false;
  Form1.MenuItem_arrondi_normal_inc.Checked:=true;
  option_arrondi_superieur_incertitude:=false;
end;

procedure TForm1.MenuItem_arrondi_sup_incClick(Sender: TObject);
begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=true;
  Form1.MenuItem_arrondi_normal_inc.Checked:=false;
  option_arrondi_superieur_incertitude:=true;
end;

procedure TForm1.Enregistrer(nom_fifichier:string;Sender: TObject);
var liste_lignes_a_sauver:tstringlist;
 i,iii:integer;
begin

   liste_lignes_a_sauver:=tstringlist.Create;
     liste_lignes_a_sauver.Add('VERSION 2');
   liste_lignes_a_sauver.Add('option_tronque_a_zero_quand_incertitude_trop_grande');
   if option_tronque_a_zero_quand_incertitude_trop_grande then
    liste_lignes_a_sauver.Add('true') else liste_lignes_a_sauver.Add('false');

 liste_lignes_a_sauver.Add('option_arrondi_superieur_incertitude');
   if option_arrondi_superieur_incertitude then
    liste_lignes_a_sauver.Add('true') else liste_lignes_a_sauver.Add('false');


                liste_lignes_a_sauver.Add('nombre_par_echantillon');
                liste_lignes_a_sauver.Add(inttostr(nombre_par_echantillon));


                liste_lignes_a_sauver.Add('nombre_de_classes');
                liste_lignes_a_sauver.Add(inttostr(nombre_de_classes));

             liste_lignes_a_sauver.Add('symbole_grandeur_sortie');
             liste_lignes_a_sauver.Add(symbole_grandeur_sortie);

             liste_lignes_a_sauver.Add('symbole_unite');
             liste_lignes_a_sauver.Add(symbole_unite);

            liste_lignes_a_sauver.Add('expression');
            liste_lignes_a_sauver.Add(chaine_expr);

            liste_lignes_a_sauver.Add('nombre_mesurandes');
            liste_lignes_a_sauver.Add(inttostr(nombre_mesurandes));

            for i:=1 to nombre_mesurandes do begin
             liste_lignes_a_sauver.Add('mesurande');
           liste_lignes_a_sauver.Add('nom_mesurande');
            liste_lignes_a_sauver.Add(liste_mesurandes[i-1].nom_mesurande);
             liste_lignes_a_sauver.Add('descriptif');
            liste_lignes_a_sauver.Add(liste_mesurandes[i-1].descriptif_mesurande);
            liste_lignes_a_sauver.Add('estimation');
                liste_lignes_a_sauver.Add(myfloattostr(liste_mesurandes[i-1].estimateur));
               liste_lignes_a_sauver.Add('nombre_erreurs');
                liste_lignes_a_sauver.Add(inttostr(liste_mesurandes[i-1].nombre_erreurs));
                liste_lignes_a_sauver.Add('liste_indices_erreurs');
               if  liste_mesurandes[i-1].nombre_erreurs>0 then
               for iii:=1 to liste_mesurandes[i-1].nombre_erreurs do
               liste_lignes_a_sauver.Add(inttostr(liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[iii-1]));

            end;

             liste_lignes_a_sauver.Add('nombre_distributions');
            liste_lignes_a_sauver.Add(inttostr(nombre_distributions));

           for i:=1 to nombre_distributions do begin
           liste_lignes_a_sauver.Add('distribution');
           liste_lignes_a_sauver.Add('nom_variable');
            liste_lignes_a_sauver.Add(liste_distributions[i-1].nom_variable);
            liste_lignes_a_sauver.Add('indice_de_la_variable_correspondante');
             liste_lignes_a_sauver.Add(inttostr(liste_distributions[i-1].indice_de_la_variable_correspondante));

            liste_lignes_a_sauver.Add('descriptif');
            liste_lignes_a_sauver.Add(liste_distributions[i-1].descriptif);
            liste_lignes_a_sauver.Add('type_AB');
            if liste_distributions[i-1].tyAB=type_A then
            liste_lignes_a_sauver.Add('type_A') else
              liste_lignes_a_sauver.Add('type_B');
            liste_lignes_a_sauver.Add('type_distribution');
            case  liste_distributions[i-1].tyty of
             d_normale: liste_lignes_a_sauver.Add('d_normale');
              d_student: liste_lignes_a_sauver.Add('d_student');
               d_rectangle: liste_lignes_a_sauver.Add('d_rectangle');
                d_triangle: liste_lignes_a_sauver.Add('d_triangle');
                 d_trapeze: liste_lignes_a_sauver.Add('d_trapeze');
                  d_arcsin: liste_lignes_a_sauver.Add('d_arcsin');
                    end;
                 liste_lignes_a_sauver.Add('defini_par');
                case  liste_distributions[i-1].defini_par of
                 par_incertitude_type: liste_lignes_a_sauver.Add('par_incertitude_type');
                 par_ecart_type_echantionnal: liste_lignes_a_sauver.Add('par_ecart_type_echantionnal');
                 par_incertitude_elargie: liste_lignes_a_sauver.Add('par_incertitude_elargie');
                 par_demi_etendue: liste_lignes_a_sauver.Add('par_demi_etendue');
                end;
                liste_lignes_a_sauver.Add('parametres');
                liste_lignes_a_sauver.Add('moyenne');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].moyenne));
                 liste_lignes_a_sauver.Add('incertitude_type');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].incertitude_type));
                liste_lignes_a_sauver.Add('demi_etendue');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue));
                liste_lignes_a_sauver.Add('incertitude_elargie');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].incertitude_elargie));
                liste_lignes_a_sauver.Add('pourcentage');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].pourcentage));
                liste_lignes_a_sauver.Add('ecart_type_echantionnal');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].ecart_type_echantionnal));
                liste_lignes_a_sauver.Add('demi_etendue_bas');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue_bas));
                liste_lignes_a_sauver.Add('demi_etendue_haut');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue_haut));
                 liste_lignes_a_sauver.Add('degres_de_liberte');
                liste_lignes_a_sauver.Add(inttostr(liste_distributions[i-1].degres_de_liberte));
                liste_lignes_a_sauver.Add('inc_rel_sur_inc');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].inc_rel_sur_inc));
                liste_lignes_a_sauver.Add('degres_de_liberte_effectif');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].degres_de_liberte_effectif));
                 liste_lignes_a_sauver.Add('student_nombre_mesures');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].student_nombre_mesures));
                if ((liste_distributions[i-1].tyty=d_student) and (liste_distributions[i-1].student_nombre_mesures>1)) then
                for iii:=1 to  liste_distributions[i-1].student_nombre_mesures do
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].student_liste_mesures[iii-1]));


           end;
            liste_lignes_a_sauver.Add('commentaires');
                liste_lignes_a_sauver.Add('nombre_lignes_commentaires');
                liste_lignes_a_sauver.Add(inttostr(memo_commentaires.Lines.Count));
                 if memo_commentaires.Lines.Count>0 then
                for iii:=1 to memo_commentaires.Lines.Count do
                liste_lignes_a_sauver.Add(memo_commentaires.Lines[iii-1]);




         try
        liste_lignes_a_sauver.SaveToFile(utf8tosys(nom_fifichier));
         except
       application.MessageBox(pchar('Impossible d''écrire le fichier '+nom_fichier_sauvegarde+' ! Vérifiez les droits sur le dossier.'),
       pchar('Attention !'),mb_ok);

         end;


   liste_lignes_a_sauver.Free;

end;

procedure TForm1.MenuItem_enregistrerClick(Sender: TObject);
begin
  if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;
  if nom_fichier_sauvegarde<>'' then Form1.Enregistrer(nom_fichier_sauvegarde,Sender) else
    begin
  savedialog1.InitialDir:=repertoire_exemples;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;
   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
 Form1.Enregistrer(nom_fichier_sauvegarde,Sender);


    end;

end;

procedure TForm1.MenuItem_enregistrer_exemplesClick(Sender: TObject);
label 1111;
begin
   if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

  1111:
  savedialog1.InitialDir:=repertoire_exemples;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;
    if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi3, [
   nom_fichier_sauvegarde])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
 Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem_enregistrer_persoClick(Sender: TObject);
label 1111;
begin
 if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

1111:
  savedialog1.InitialDir:=repertoire_propagation_perso;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;

  if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi2, [
   nom_fichier_sauvegarde])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));


  Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem_incertitudeClick(Sender: TObject);
begin

   with FormIncertitudeTropGrande do begin
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  if option_tronque_a_zero_quand_incertitude_trop_grande then radiogroup1.itemindex:=0 else
 radiogroup1.itemindex:=1;
end;
   FormIncertitudeTropGrande.showmodal;
   option_tronque_a_zero_quand_incertitude_trop_grande:=(FormIncertitudeTropGrande.RadioGroup1.ItemIndex=0);
end;

procedure TForm1.MenuItem_montecarloClick(Sender: TObject);
begin
   with Form_montecarlo do begin
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
spinedit_puissance_de_N.value:=puissance_de_nombre_par_echantillon;
spinedit1.value:=nombre_de_classes;


end;
Form_montecarlo.showmodal;
end;

procedure TForm1.MenuItem_nouveauClick(Sender: TObject);
begin
   Form1.RemetAZero(Sender);
end;

procedure TForm1.MenuItem_ouvrir_dernierClick(Sender: TObject);
begin
  opendialog2.InitialDir:=dernier_repertoire_utilise_chargement;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
           opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);
end;


procedure TForm1.RemetAZero(Sender: TObject);
   var i,iii:integer;
begin


 nombre_mesurandes:=0;
 nombre_distributions:=0;
 setlength(liste_mesurandes,0);
 setlength(liste_distributions,0);
  setlength(liste_distribution_est_traitee,0);
  expression_validee:=false;
    chaine_expr:='';
       old_chaine_expr:='';
       Edit_saisie_expression.Text:='';
       tous_calculs_faits:=false;
    nom_fichier_sauvegarde:='';
     nom_fichier_chargement:='';
     memo_commentaires.Clear;
       pagecontrol1.ActivePage:=tabsheet_expression;





end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if radiogroup1.ItemIndex=0 then  chart1.CopyToClipboardBitmap;
if radiogroup1.ItemIndex=1 then  chart2.CopyToClipboardBitmap;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
   CopyStringGridToClipboard(stringgrid4);
end;

procedure TForm1.ChargerFichier(nom_fifichier:string;Sender: TObject);
var  s3,s1,s2,s,s4:string;   version2:boolean;
iii,i,nono,kkk,boucle:integer; rere:float;  toto:TCharEncStream; liste_lignes_fichier_gum:tstringlist;
expression_essai:string;  nom_variable,descri:string; indice_variable_a_traiter:integer;

begin




 toto:=TCharEncStream.create;
     try
       toto.LoadFromFile(UTF8ToSys(nom_fifichier));
      except
    application.MessageBox(pchar(Format(rsImpossibleDe, [nom_fifichier])),
    pchar(rsHLas), mb_ok);
    exit;
  end;


      Form1.RemetAZero(Sender);

      liste_lignes_fichier_gum:=tstringlist.Create;
      liste_lignes_fichier_gum.Text:=toto.UTF8Text;
      toto.Free;
  i:=0;

 inc(i);

 version2:=liste_lignes_fichier_gum[i-1]='VERSION 2';
  if version2 then inc(i);

 if liste_lignes_fichier_gum[i-1]='option_tronque_a_zero_quand_incertitude_trop_grande' then begin
       inc(i);
   option_tronque_a_zero_quand_incertitude_trop_grande:=liste_lignes_fichier_gum[i-1]='true';

   inc(i);
 end;

 if liste_lignes_fichier_gum[i-1]='option_arrondi_superieur_incertitude' then begin
      inc(i);
   option_arrondi_superieur_incertitude:=liste_lignes_fichier_gum[i-1]='true';
   inc(i);
   if option_arrondi_superieur_incertitude then begin
   Form1.MenuItem_arrondi_sup_inc.Checked:=true;
  Form1.MenuItem_arrondi_normal_inc.Checked:=false;
 end else begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=false;
  Form1.MenuItem_arrondi_normal_inc.Checked:=true;
   end;
       end;




  if liste_lignes_fichier_gum[i-1]='genre_affichage_incertitude' then begin
  inc(i);

if liste_lignes_fichier_gum[i-1]='sans_point_decimal' then  mon_genre_affichage_incertitude:=sans_point_decimal;
 if liste_lignes_fichier_gum[i-1]= 'sans_puissance_de_dix'then  mon_genre_affichage_incertitude:=sans_puissance_de_dix;
  if liste_lignes_fichier_gum[i-1]='avec_un_chiffre_avant_virgule_pour_valeur'then  mon_genre_affichage_incertitude:=avec_un_chiffre_avant_virgule_pour_valeur;
 if liste_lignes_fichier_gum[i-1]= 'avec_un_chiffre_avant_virgule_pour_incertitude'then  mon_genre_affichage_incertitude:=avec_un_chiffre_avant_virgule_pour_incertitude;

  inc(i);
  end;
   if liste_lignes_fichier_gum[i-1]='longueur_chaine_agreable_incertitude' then begin
  inc(i);
   ma_longueur_chaine_agreable_incertitude:=strtoint(liste_lignes_fichier_gum[i-1]);
   inc(i);
   end;


 if liste_lignes_fichier_gum[i-1]='genre_affichage_valeur_individuelle' then begin
  inc(i);

 if liste_lignes_fichier_gum[i-1]='_sans_point_decimal' then  mon_genre_affichage_valeur_individuelle:=_sans_point_decimal;
  if liste_lignes_fichier_gum[i-1]= '_sans_puissance_de_dix' then   mon_genre_affichage_valeur_individuelle:=_sans_puissance_de_dix;
  if liste_lignes_fichier_gum[i-1]= '_avec_un_chiffre_avant_virgule' then   mon_genre_affichage_valeur_individuelle:=_avec_un_chiffre_avant_virgule;

  inc(i);
  end;
   if liste_lignes_fichier_gum[i-1]='longueur_chaine_agreable_valeur_individuelle' then begin
  inc(i);
   ma_longueur_chaine_agreable_valeur_individuelle:=strtoint(liste_lignes_fichier_gum[i-1]);
   inc(i);
   end;





 if liste_lignes_fichier_gum[i-1]='nombre_par_echantillon' then begin
   inc(i);
   nombre_par_echantillon:=strtoint(liste_lignes_fichier_gum[i-1]);

   inc(i);
   end;


 if liste_lignes_fichier_gum[i-1]='nombre_de_classes' then begin
   inc(i);
   nombre_de_classes:=strtoint(liste_lignes_fichier_gum[i-1]);

   inc(i);
   end;


   if liste_lignes_fichier_gum[i-1]='symbole_grandeur_sortie' then begin
   inc(i);
   symbole_grandeur_sortie:=liste_lignes_fichier_gum[i-1];
   edit_nom_grandeur_sortie.Text:=symbole_grandeur_sortie;

   inc(i);
   end;



   if liste_lignes_fichier_gum[i-1]='symbole_unite' then begin
   inc(i);
   symbole_unite:=liste_lignes_fichier_gum[i-1];
   edit_saisie_unite.Text:=symbole_unite;

   inc(i);
   end;




   if liste_lignes_fichier_gum[i-1]='expression' then begin
     inc(i);
     expression_essai:=liste_lignes_fichier_gum[i-1];
     try
         Expr_temp:=TExpression.Create(expression_essai);

        except
                    application.MessageBox(pchar(rsErreurDeSynt),pchar( rsAttention), mb_ok);
                       exit;
          end;
        inc(i);
        end;

    expression_validee:=true;
    chaine_expr:=expression_essai;
       old_chaine_expr:=chaine_expr;
       Edit_saisie_expression.Text:=expression_essai;
      Liste_Variables:=Expr_temp.SymbolicValueNames;






    if version2 then begin


  if liste_lignes_fichier_gum[i-1]='nombre_mesurandes' then begin
     inc(i);
     try
    nombre_mesurandes:=strtoint(liste_lignes_fichier_gum[i-1]);

     except
        application.MessageBox(pchar('Erreur sur le nombre de mesurandes'),pchar('Attention'),mb_ok);
        exit;
     end;
     inc(i);
    end;


   if Liste_Variables.Count<>nombre_mesurandes then begin
     application.MessageBox(pchar('Nombre de mesurandes <> nombre variables dans expression'),pchar('Attention'),mb_ok);
        exit;
     end;

        setlength(liste_mesurandes,nombre_mesurandes);

        for boucle:=1 to nombre_mesurandes do begin
          inc(i);
    if liste_lignes_fichier_gum[i-1]='nom_mesurande'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].nom_mesurande:=liste_lignes_fichier_gum[i-1];
            inc(i);
            end;
       if liste_lignes_fichier_gum[i-1]='descriptif'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].descriptif_mesurande:=liste_lignes_fichier_gum[i-1];
            inc(i);
            end;
        if liste_lignes_fichier_gum[i-1]='estimation'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].estimateur:=mystrtofloat(liste_lignes_fichier_gum[i-1]);
            inc(i);
            end;
         if liste_lignes_fichier_gum[i-1]='nombre_erreurs'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].nombre_erreurs:=strtoint(liste_lignes_fichier_gum[i-1]);
            inc(i);
            end;
         inc(i);

         setlength(liste_mesurandes[boucle-1].liste_des_indices_des_sources_derreur,liste_mesurandes[boucle-1].nombre_erreurs);
         if  liste_mesurandes[boucle-1].nombre_erreurs>0 then
         for kkk:=1 to  liste_mesurandes[boucle-1].nombre_erreurs do
         begin
          liste_mesurandes[boucle-1].liste_des_indices_des_sources_derreur[kkk-1]:=strtoint(liste_lignes_fichier_gum[i-1]);
          inc(i);
          end;
         end;   {boucle de lecture des mesurandes}




         if liste_lignes_fichier_gum[i-1]='nombre_distributions' then begin
     inc(i);
     try
    nombre_distributions:=strtoint(liste_lignes_fichier_gum[i-1]);

     except
        application.MessageBox(pchar('Erreur sur le nombre de distributions'),pchar('Attention'),mb_ok);
        exit;
     end;
     inc(i);
    end;

       end; {version2}





    if not(version2) then begin
    nombre_mesurandes:=Liste_Variables.Count;

    nombre_distributions:=nombre_mesurandes;

      setlength(liste_mesurandes,nombre_mesurandes);
            end;


    setlength(liste_distributions,nombre_distributions);
    setlength(liste_distribution_est_traitee,nombre_distributions);
     for iii:=1 to nombre_distributions do begin
    if not(version2) then    liste_distributions[iii-1].nom_variable:=liste_variables[iii-1]+'_S1';

 if not(version2) then     liste_mesurandes[iii-1].nom_mesurande:=liste_variables[iii-1];
      liste_distributions[iii-1].descriptif:='';
      liste_distribution_est_traitee[iii-1]:=false;
      liste_distributions[iii-1].moyenne:=0;
      liste_distributions[iii-1].defini_par:=par_incertitude_type;
      liste_distributions[iii-1].tyty:=d_normale;
      liste_distributions[iii-1].tyAB:=type_B;
      liste_distributions[iii-1].degres_de_liberte:=0;
      liste_distributions[iii-1].degres_de_liberte_effectif:=0;
      liste_distributions[iii-1].demi_etendue:=0;
      liste_distributions[iii-1].demi_etendue_bas:=0;
      liste_distributions[iii-1].demi_etendue_haut:=0;
      liste_distributions[iii-1].ecart_type_echantionnal:=0;
      liste_distributions[iii-1].incertitude_elargie:=0;
      liste_distributions[iii-1].incertitude_type:=0;
      liste_distributions[iii-1].inc_rel_sur_inc:=0;
      liste_distributions[iii-1].pourcentage:=0;
      liste_distributions[iii-1].student_nombre_mesures:=0;
       end;






     Initialise_Generateur(0);






     for boucle:=1 to nombre_distributions do begin

       if liste_lignes_fichier_gum[i-1]='distribution' then begin
     inc(i);

     if liste_lignes_fichier_gum[i-1]<>'nom_variable' then begin
     application.MessageBox(pchar(rsNom_variable), pchar(rsAttention3), mb_ok
       );
      exit;
      end;


    inc(i);
    nom_variable:=liste_lignes_fichier_gum[i-1];

      if not(version2) then begin
    indice_variable_a_traiter:=liste_variables.IndexOf(nom_variable);
    if  indice_variable_a_traiter=-1 then begin
    application.MessageBox(pchar(Format(rsVariableTrou, [nom_variable])), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
    end else indice_variable_a_traiter:=boucle-1;

    if not(version2) then begin
    liste_distributions[indice_variable_a_traiter].indice_de_la_variable_correspondante:=indice_variable_a_traiter;
    liste_mesurandes[indice_variable_a_traiter].nombre_erreurs:=1;
    setlength( liste_mesurandes[indice_variable_a_traiter].liste_des_indices_des_sources_derreur,1);
    liste_mesurandes[indice_variable_a_traiter].liste_des_indices_des_sources_derreur[0]:=indice_variable_a_traiter;
      end;

    if version2 then begin
    liste_distributions[indice_variable_a_traiter].nom_variable:=nom_variable;
    inc(i); inc(i);
    liste_distributions[indice_variable_a_traiter].indice_de_la_variable_correspondante:=strtoint(liste_lignes_fichier_gum[i-1]);
            end;


   inc(i);

   if liste_lignes_fichier_gum[i-1]='descriptif' then begin
   inc(i);
   descri:=liste_lignes_fichier_gum[i-1];
   inc(i);
   end else descri:='';
  liste_distributions[indice_variable_a_traiter].descriptif:=descri;

   if liste_lignes_fichier_gum[i-1]<>'type_AB' then begin
    application.MessageBox(pchar(rsType_ABAtten), pchar(
      rsAttention3), mb_ok);
      exit;
      end;


    inc(i);
    if liste_lignes_fichier_gum[i-1]='type_A' then
   liste_distributions[indice_variable_a_traiter].tyAB:=type_A else
    liste_distributions[indice_variable_a_traiter].tyAB:=type_B  ;

     inc(i);

    if liste_lignes_fichier_gum[i-1]<>'type_distribution' then begin
    application.MessageBox(pchar(rsType_distrib), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

   inc(i);
   if  liste_lignes_fichier_gum[i-1]='d_normale' then  liste_distributions[indice_variable_a_traiter].tyty:=d_normale;
   if  liste_lignes_fichier_gum[i-1]='d_student' then  liste_distributions[indice_variable_a_traiter].tyty:=d_student;
   if  liste_lignes_fichier_gum[i-1]='d_rectangle' then  liste_distributions[indice_variable_a_traiter].tyty:=d_rectangle;
   if  liste_lignes_fichier_gum[i-1]='d_triangle' then  liste_distributions[indice_variable_a_traiter].tyty:=d_triangle;
   if  liste_lignes_fichier_gum[i-1]='d_trapeze' then  liste_distributions[indice_variable_a_traiter].tyty:=d_trapeze;
   if  liste_lignes_fichier_gum[i-1]='d_arcsin' then  liste_distributions[indice_variable_a_traiter].tyty:=d_arcsin;
   inc(i);


   if liste_lignes_fichier_gum[i-1]<>'defini_par' then begin
    application.MessageBox(pchar(rsDefini_parAt), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

   inc(i);
  if  liste_lignes_fichier_gum[i-1]='par_incertitude_type' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_incertitude_type;
   if  liste_lignes_fichier_gum[i-1]='par_ecart_type_echantionnal' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_ecart_type_echantionnal;
    if  liste_lignes_fichier_gum[i-1]='par_incertitude_elargie' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_incertitude_elargie;
     if  liste_lignes_fichier_gum[i-1]='par_demi_etendue' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_demi_etendue;
    inc(i);

 if liste_lignes_fichier_gum[i-1]<>'parametres' then begin
    application.MessageBox(pchar(rsParametresAt), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'moyenne' then begin
    application.MessageBox(pchar(rsMoyenneAtten), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].moyenne:=0;
 if not(version2) then  liste_mesurandes[indice_variable_a_traiter].estimateur:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'incertitude_type' then begin
    application.MessageBox(pchar(rsIncertitude_), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].incertitude_type:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'demi_etendue' then begin
    application.MessageBox(pchar(rsDemi_etendue), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].demi_etendue:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
 if liste_lignes_fichier_gum[i-1]<>'incertitude_elargie' then begin
    application.MessageBox(pchar(rsIncertitude_2), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].incertitude_elargie:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'pourcentage' then begin
    application.MessageBox(pchar(rsPourcentageA), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].pourcentage:=mystrtofloat(liste_lignes_fichier_gum[i-1]);



 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'ecart_type_echantionnal' then begin
    application.MessageBox(pchar(rsEcart_type_e), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].ecart_type_echantionnal:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'demi_etendue_bas' then begin
    application.MessageBox(pchar(rsDemi_etendue2), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].demi_etendue_bas:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'demi_etendue_haut' then begin
     application.MessageBox(pchar(rsDemi_etendue3), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].demi_etendue_haut:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'degres_de_liberte' then begin
     application.MessageBox(pchar(rsDegres_de_li), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].degres_de_liberte:=strtoint(liste_lignes_fichier_gum[i-1]);

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'inc_rel_sur_inc' then begin
     application.MessageBox(pchar(rsInc_rel_sur_), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].inc_rel_sur_inc:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'degres_de_liberte_effectif' then begin
     application.MessageBox(pchar(rsDegres_de_li2), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].degres_de_liberte_effectif:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'student_nombre_mesures'   then begin
     application.MessageBox(pchar(rsStudent_nomb), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].student_nombre_mesures:=strtoint(liste_lignes_fichier_gum[i-1]);

  if (liste_distributions[indice_variable_a_traiter].tyty=d_student) and (liste_distributions[indice_variable_a_traiter].student_nombre_mesures>1) then
  begin
  setlength(liste_distributions[indice_variable_a_traiter].student_liste_mesures,liste_distributions[indice_variable_a_traiter].student_nombre_mesures);
  for iii:=1 to  liste_distributions[indice_variable_a_traiter].student_nombre_mesures do
  begin
  inc(i);
  liste_distributions[indice_variable_a_traiter].student_liste_mesures[iii-1]:=mystrtofloat(liste_lignes_fichier_gum[i-1]);
  end; end;
 inc(i);





     {test si commentaire ds le champ de la variable: c'était un bug de la version 1.2}
    if ((liste_lignes_fichier_gum[i-1]='commentaires') and (boucle<nombre_distributions))   then begin
        inc(i,2);
   nono:=strtoint(liste_lignes_fichier_gum[i-1]);

   //memo_commentaires.Clear;
   if nono>0 then  for iii:=1 to nono do begin
   inc(i);

   // memo_commentaires.Lines.Add(liste_lignes_fichier_gum[i-1]);
   end;
     inc(i);
     end;


     screen.Cursor:=crhourglass;


  end;
 liste_distribution_est_traitee[indice_variable_a_traiter]:=true;






   end; {de la boucle sur les variables}






  if liste_lignes_fichier_gum[i-1]<>'commentaires'   then begin
     application.MessageBox(pchar(rsCommentaires), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
   if liste_lignes_fichier_gum[i-1]<>'nombre_lignes_commentaires'   then begin
     application.MessageBox(pchar(rsNombre_ligne), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
   inc(i);
   nono:=strtoint(liste_lignes_fichier_gum[i-1]);
   memo_commentaires.Clear;
   if nono>0 then  for iii:=1 to nono do begin
   inc(i);
    memo_commentaires.Lines.Add(liste_lignes_fichier_gum[i-1]);
   end;

 if (version2 and (liste_lignes_fichier_gum.Count>i)) then begin
inc(i);
if liste_lignes_fichier_gum[i-1]='correlations' then begin
for iii:=1 to nombre_distributions do
for kkk:=1 to nombre_distributions do
begin
inc(i);
{if  liste_lignes_fichier_gum[i-1]='c_correlation'
then liste_descripteur_correlation[iii-1,kkk-1].t_correlation:=c_correlation else
 liste_descripteur_correlation[iii-1,kkk-1].t_correlation:=c_covariance;}
inc(i);
{liste_descripteur_correlation[iii-1,kkk-1].valeur:=strtofloat(liste_lignes_fichier_gum[i-1]);}
end;

end;  {fin correlation}
inc(i);
end;

{valeur de référence, ajout version 2.40}
if (version2 and (liste_lignes_fichier_gum.Count>i)) then begin
inc(i);
if liste_lignes_fichier_gum[i-1]='valeur de reference' then begin
inc(i);
   Edit_valeur_reference.Text:=liste_lignes_fichier_gum[i-1];
    valeur_reference:=superstrtofloat(Edit_valeur_reference.Text);
 end;
end;
{valeur de référence, ajout version 2.40}


 liste_lignes_fichier_gum.Free;


 for i:=1 to nombre_mesurandes  do
 liste_mesurandes[i-1].estimateur:=NAN;

  for i:=1 to nombre_distributions  do
 liste_distributions[i-1].incertitude_type:=NAN;

 form1.rafraichitstringgridentree(sender);
 nom_fichier_sauvegarde:=nom_fichier_chargement;

 pagecontrol1.ActivePage:=TabSheet_expression;
// Form1.BitBtn1Click(Sender);
  screen.Cursor:=crdefault;










end;



procedure TForm1.MenuItem_ouvrir_exemplesClick(Sender: TObject);
begin
  opendialog2.InitialDir:=repertoire_exemples;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
        opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);
end;

procedure TForm1.MenuItem_ouvrir_personnelClick(Sender: TObject);
begin
  opendialog2.InitialDir:=repertoire_propagation_perso;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
            opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.ItemIndex=0 then begin
  chart1.Visible:=true;
  chart2.Visible:=false;
  end;
  if radiogroup1.ItemIndex=1 then begin
  chart2.Visible:=true;
  chart1.Visible:=false;
  end;
end;







procedure TForm1.SpeedButton14Click(Sender: TObject);
begin
 if radiogroup1.ItemIndex=0 then
    chart1.CopyToClipboardBitmap;
 if radiogroup1.ItemIndex=1 then
    chart2.CopyToClipboardBitmap;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  CopyStringGridToClipboard(StringGrid1);
end;










procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid4);
end;





procedure TForm1.StaticText11Click(Sender: TObject);

  var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:='http://www.bipm.org/utils/common/documents/jcgm/JCGM_100_2008_E.pdf';
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end;
end;

procedure TForm1.StaticText13Click(Sender: TObject);

  var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:='http://www.bipm.org/utils/common/documents/jcgm/JCGM_101_2008_E.pdf';
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end
end;


function isligne_mesurande(row:integer; var indice_variable_pour_ajout_source_erreur_a_debut_zero:integer):boolean;
var i,li:integer;
begin

 if (row=0) or (nombre_mesurandes=0) then begin
  isligne_mesurande:=false;
  exit;
  end;


 if row=1 then begin
  indice_variable_pour_ajout_source_erreur_a_debut_zero:=0;
   isligne_mesurande:=true;
   exit;
   end;

    li:=1;
 for i:=1 to nombre_mesurandes do
 begin
li:=li+2+liste_mesurandes[i-1].nombre_erreurs;
    if row=li then  begin
    indice_variable_pour_ajout_source_erreur_a_debut_zero:=i;
   isligne_mesurande:=true;
   exit;
    end;

 end;
  isligne_mesurande:=false;

end;

function isligne_intercalaire(row:integer):boolean;
var i,li:integer;
begin

 if (row<=1) or (nombre_mesurandes=0)  then begin
  isligne_intercalaire:=false;
  exit;
  end;



    li:=0;
 for i:=1 to nombre_mesurandes do
 begin
li:=li+2+liste_mesurandes[i-1].nombre_erreurs;
    if row=li then  begin
       isligne_intercalaire:=true;
   exit;
    end;

 end;
  isligne_intercalaire:=false;

end;




function isligne_distribution(row:integer; var indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer):boolean;
var i,li:integer;
begin
 if (row<=1) or (nombre_mesurandes=0) or (nombre_distributions=0) then begin
  isligne_distribution:=false;
   exit;
 end;

 if  (isligne_mesurande(row,indice_variable_pour_modif_source_erreur_a_debut_zero)
 or
 isligne_intercalaire(row) ) then begin
 isligne_distribution:=false;
 exit;
 end;

 i:=row;
 repeat
   dec(i);
 until isligne_mesurande(i,indice_variable_pour_modif_source_erreur_a_debut_zero);

 indice_distribution_a_debut_zero:=liste_mesurandes[indice_variable_pour_modif_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur[row-i-1];


  isligne_distribution:=true;

end;


procedure TForm1.rafraichitstringgridentree(sender:tobject);
  var i,j,liligne:integer;
 begin
  if nombre_mesurandes=0 then exit;
  StringGrid_entree.Clear;
  StringGrid_entree.ColCount:=6;
  StringGrid_entree.RowCount:=nombre_mesurandes*2+nombre_distributions+1;
  liligne:=0;
  form1.StringGrid_entree.Cells[0, 0]:=rsMesurande2;
    form1.StringGrid_entree.Cells[3, 0]:=rsTypeEstimati;
      form1.StringGrid_entree.Cells[1, 0]:=rsEstimateur;
      // form1.StringGrid_entree.Cells[2, 0]:=rsAjouterSourc;
     //  form1.StringGrid_entree.Cells[3, 0]:=rsSupprimerSou;
       form1.StringGrid_entree.Cells[2, 0]:=rsSymboleErreu;
      form1.StringGrid_entree.Cells[4, 0]:=rsIncertitudeT2;
     // form1.StringGrid_entree.Cells[7, 0]:=rsTypeDeDistri;
     // form1.StringGrid_entree.Cells[8, 0]:=rsTracDistribu;
     // form1.StringGrid_entree.Cells[9, 0]:=rsTracDensit;
      form1.StringGrid_entree.Cells[5, 0]:=rsDescriptif;

for i:=1 to nombre_mesurandes do begin
 inc(liligne);
 StringGrid_entree.Cells[0,liligne]:=liste_mesurandes[i-1].nom_mesurande;
// StringGrid_entree.Cells[1,liligne]:=floattostr(liste_mesurandes[i-1].estimateur);
 // StringGrid_entree.Cells[2,liligne]:='+';
  StringGrid_entree.Cells[5,liligne]:=liste_mesurandes[i-1].descriptif_mesurande;

  if myisnan(liste_mesurandes[i-1].estimateur) then
  form1.StringGrid_entree.Cells[1, liligne]:=rsClicIciPourS3 else
   form1.StringGrid_entree.Cells[1, liligne]:=myfloattostr(liste_mesurandes[i-1].estimateur);

  if liste_mesurandes[i-1].nombre_erreurs>0 then
  for j:=1 to liste_mesurandes[i-1].nombre_erreurs do begin
  inc(liligne);
  // StringGrid_entree.Cells[3,liligne]:='-';
   StringGrid_entree.Cells[2,liligne]:=liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].nom_variable;
       case liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].tyAB of
      type_A: form1.StringGrid_entree.Cells[3,liligne]:='A';
      type_B: form1.StringGrid_entree.Cells[3,liligne]:='B';
       end;

       if  myisnan(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].incertitude_type) then
          form1.StringGrid_entree.Cells[4, liligne]:=rsClicIciPourS2 else
       case liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].defini_par of
           par_incertitude_type:
            form1.StringGrid_entree.Cells[4, liligne]:=myfloattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].incertitude_type);
           par_incertitude_elargie:
            form1.StringGrid_entree.Cells[4, liligne]:=myfloattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].incertitude_elargie);
           par_demi_etendue:
            form1.StringGrid_entree.Cells[4, liligne]:=myfloattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].demi_etendue);
            par_ecart_type_echantionnal:
             form1.StringGrid_entree.Cells[4, liligne]:=myfloattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].ecart_type_echantionnal);
           end;




  //StringGrid_entree.Cells[6,liligne]:=floattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].incertitude_type);
 { case liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].tyty of
    d_student: form1.StringGrid_entree.Cells[7, liligne]:=rsStudent;
    d_normale: form1.StringGrid_entree.Cells[7, liligne]:=rsNormaleGauss;
    d_rectangle: form1.StringGrid_entree.Cells[7, liligne]:=rsRectangulair;
    d_triangle: form1.StringGrid_entree.Cells[7, liligne]:=rsTriangulaire;
    d_trapeze:  form1.StringGrid_entree.Cells[7, liligne]:=rsTrapZoDale;
    d_arcsin:   form1.StringGrid_entree.Cells[7, liligne]:=rsDRivEDArcsin;
           end;
 form1.StringGrid_entree.Cells[8, liligne]:=rsClicIci;
       form1.StringGrid_entree.Cells[9,liligne]:=rsClicIci; }
       form1.StringGrid_entree.Cells[5,liligne]:=liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].descriptif;
  end;
  inc(liligne);

end;

form1.StringGrid_entree.AutoSizeColumns;
 form1.StringGrid_entree.ColWidths[0]:=trunc(form1.StringGrid_entree.ColWidths[0]*1.2);
 form1.StringGrid_entree.ColWidths[1]:=trunc(form1.StringGrid_entree.ColWidths[1]*1.2);
 form1.StringGrid_entree.ColWidths[4]:=trunc(form1.StringGrid_entree.ColWidths[4]*1.2);
 //car police bold
 end;




procedure TForm1.StringGrid_entreeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var repmode,i,j,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero:integer;
 colonne,ligne:integer;
   begin
    saisie_mesures_effectuee:=false;
     if (nombre_mesurandes=0) then exit;
     StringGrid_entree.MouseToCell(x,y,colonne,ligne);
     if ligne=0 then exit;



   {modif valeur mesurande}
   if    (isligne_mesurande(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero) and (colonne=1))  then begin

    with saisie_estimateur do begin
       if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   if not(myisnan(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur)) then
     edit_saisie_estimateur.text:=floattostr(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur)
     else edit_saisie_estimateur.text:='';
   end;
    repmode:=saisie_estimateur.ShowModal;
  if repmode=mrok then begin
  liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur:=superstrtofloat(saisie_estimateur.edit_saisie_estimateur.text);
   Form1.rafraichitstringgridentree(sender);
    end;
  tous_calculs_faits:=false;
  exit;
   end;
    {fin modif valeur mesurande}




       {modif erreur}
      if ((colonne=4) and    isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero) )
      then begin
      indice_distribution:=indice_distribution_a_debut_zero+1;
       indice_mesurande:=indice_variable_pour_ajout_source_erreur_a_debut_zero;



       if (liste_distributions[indice_distribution-1].tyAB=type_A)  then begin
         if ((not(myisnan(liste_distributions[indice_distribution-1].incertitude_type))) and (liste_distributions[indice_distribution-1].student_nombre_mesures>1)) then
      with Form_aidecalcul do begin
 StringGrid1.RowCount:=1+liste_distributions[indice_distribution-1].student_nombre_mesures;
 for i:=1 to liste_distributions[indice_distribution-1].student_nombre_mesures do begin
StringGrid1.Cells[1,i]:=floattostr(liste_distributions[indice_distribution-1].student_liste_mesures[i-1]);
StringGrid1.Cells[0,i]:='i';
    end;
ReCalcule(sender);
end else
with Form_aidecalcul do begin
StringGrid1.RowCount:=2;
StringGrid1.Cells[0,1]:='1';
StringGrid1.Cells[1,1]:='';
ReCalcule(sender);
end;



         with Form_saisie_type_A  do begin
             if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
           if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
           Caption:=Format(rsCaractRistiq, [liste_distributions[indice_distribution-1].nom_variable]);
           Edit_saisie_ecart_type.Text:='';
           Edit_saisie_moyenne.Text:='';
           Edit_saisie_nombre_mesures.Text:='';
           case liste_distributions[indice_distribution-1].defini_par of
           par_incertitude_type:  begin
           StaticText2.Caption:=rsIncertitudeT3;
           StaticText2.Hint:=rsLeCrAteurDuF;
           end;
           par_incertitude_elargie:  begin
            StaticText2.Caption:=rsIncertitudeL2;
           StaticText2.Hint:=Format(rsLeCrAteurDuF2, [floattostr(
             liste_distributions[indice_distribution-1].pourcentage)]);
           end;
           par_ecart_type_echantionnal:  begin
           StaticText2.Caption:=rsEcartTypeCha4;
           StaticText2.Hint:=rsLeCrAteurDuF3;
           end;
           end;  {du case}
           if liste_distributions[indice_distribution-1].defini_par=par_ecart_type_echantionnal then begin
           statictext4.Enabled:=true;
           statictext5.Enabled:=true;
           checkbox_serie_plus_longue.Enabled:=true;
           spinedit_serie_plus_longue.Enabled:=true;
            statictext4.visible:=true;
           statictext5.visible:=true;
           checkbox_serie_plus_longue.visible:=true;
           spinedit_serie_plus_longue.visible:=true;
           end else begin
            statictext4.Enabled:=false;
           statictext5.Enabled:=false;
           checkbox_serie_plus_longue.Enabled:=false;
           spinedit_serie_plus_longue.Enabled:=false;
            statictext4.visible:=false;
           statictext5.visible:=false;
           checkbox_serie_plus_longue.visible:=false;
           spinedit_serie_plus_longue.visible:=false;
           end;

           Edit_saisie_ecart_type.Hint:=StaticText2.Hint;
           if (not(myisnan(liste_distributions[indice_distribution-1].incertitude_type))) then begin
            Edit_saisie_moyenne.Text:=floattostr({liste_distributions[indice_distribution-1].moyenne}
            liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur);
            Edit_saisie_nombre_mesures.Text:=inttostr(liste_distributions[indice_distribution-1].degres_de_liberte+1);
            case liste_distributions[indice_distribution-1].defini_par of
            par_ecart_type_echantionnal: Edit_saisie_ecart_type.Text:=floattostr(liste_distributions[indice_distribution-1].ecart_type_echantionnal);
            par_incertitude_type:  Edit_saisie_ecart_type.Text:=floattostr(liste_distributions[indice_distribution-1].incertitude_type);
            par_incertitude_elargie :  Edit_saisie_ecart_type.Text:=floattostr(liste_distributions[indice_distribution-1].incertitude_elargie);
                       end;{du case}

           end;
           end; {du with form_saisie_a}

     repmode:=Form_saisie_type_A.ShowModal;
     if repmode<>mrok then exit;

 //  stringgrid_entree.Cells[2,indice_distribution]:=(Form_saisie_type_A.Edit_saisie_moyenne.Text);
  // stringgrid_entree.Cells[3,indice_distribution]:=(Form_saisie_type_A.Edit_saisie_ecart_type.Text);
  // stringgrid_entree.AutoSizeColumns;
   Form1.rafraichitstringgridentree(sender);
    exit;
      end;


   if (liste_distributions[indice_distribution-1].tyAB=type_B)  then begin

         with Form_saisie_type_B  do begin
             if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
           if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
           Caption:=Format(rsCaractRistiq, [liste_distributions[indice_distribution-1].nom_variable]);
           Edit_saisie_incertitude.Text:='';

           case liste_distributions[indice_distribution-1].defini_par of
           par_incertitude_type:
           StaticText2.Hint:=rsLeCrAteurDuF4;
           par_incertitude_elargie:
           StaticText2.Hint:=Format(rsLeCrAteurDuF5, [floattostr(
             liste_distributions[indice_distribution-1].pourcentage)]);
           par_demi_etendue:
           StaticText2.Hint:=rsLeCrAteurDuF6;
           end;
           Edit_saisie_incertitude.Hint:=StaticText2.Hint;

      if (not(myisnan(liste_distributions[indice_distribution-1].incertitude_type)))  then begin

       case liste_distributions[indice_distribution-1].defini_par of
           par_incertitude_type:
           Edit_saisie_incertitude.Text:=floattostr(liste_distributions[indice_distribution-1].incertitude_type);
           par_incertitude_elargie:
           Edit_saisie_incertitude.Text:=floattostr(liste_distributions[indice_distribution-1].incertitude_elargie);
           par_demi_etendue:
           Edit_saisie_incertitude.Text:=floattostr(liste_distributions[indice_distribution-1].demi_etendue);
           end;
      end;  end;

     repmode:=Form_saisie_type_B.ShowModal;
     if repmode<>mrok then exit;
  // stringgrid_entree.Cells[3,indice_distribution]:=(Form_saisie_type_B.Edit_saisie_incertitude.Text);
  // stringgrid_entree.AutoSizeColumns;
   Form1.rafraichitstringgridentree(sender);
    exit;
      end;






    tous_calculs_faits:=false;
     Form1.rafraichitstringgridentree(sender);



   end;


end;

procedure TForm1.StringGrid_entreeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var coco,roro:integer;  chaine:string;
  indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer;
  begin
    if (StringGrid_entree.cursor=crvsplit) or
     (StringGrid_entree.cursor=crhsplit ) then exit;

  StringGrid_entree.MouseToCell(x,y,coco,roro);

 if roro=0 then begin
  chaine:='';
   StringGrid_entree.Hint:=chaine;
  Application.ActivateHint(Mouse.CursorPos);
  exit;
  end;


   chaine:='';

   if (coco=1) and isligne_mesurande(roro,
     indice_variable_pour_modif_source_erreur_a_debut_zero) and (StringGrid_entree.Cells[coco,roro]=rsClicIciPourS3) then chaine:=
     'Clic ici pour saisir la valeur estimée de '+liste_mesurandes[indice_variable_pour_modif_source_erreur_a_debut_zero].nom_mesurande;
   if (coco=1) and isligne_mesurande(roro,
     indice_variable_pour_modif_source_erreur_a_debut_zero) and (StringGrid_entree.Cells[coco,roro]<>rsClicIciPourS3) then chaine:=
     'Clic ici pour modifier la valeur estimée de '+liste_mesurandes[indice_variable_pour_modif_source_erreur_a_debut_zero].nom_mesurande;


    if (coco=4) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero)
    then
     case liste_distributions[indice_distribution_a_debut_zero].defini_par of
           par_incertitude_type:
           chaine:=rsLeCrAteurDuF4;
           par_incertitude_elargie:
           chaine:=Format(rsLeCrAteurDuF5, [floattostr(
             liste_distributions[indice_distribution_a_debut_zero].pourcentage)]);
           par_demi_etendue:
           chaine:=rsLeCrAteurDuF6;
            par_ecart_type_echantionnal:  chaine:=rsLeCrAteurDuF3;

           end;





  if chaine<>StringGrid_entree.Hint then begin
  StringGrid_entree.Hint:=chaine;
  Application.ActivateHint(Mouse.CursorPos);
    End;
  end;

procedure TForm1.StringGrid_entreePrepareCanvas(sender: TObject; aCol,
  aRow: Integer; aState: TGridDrawState);
var i,j:integer;    MyTextStyle: TTextStyle;
begin

 StringGrid_entree.Canvas.Brush.Style:= bssolid;
 MyTextStyle:=  StringGrid_entree.Canvas.TextStyle;
 MyTextStyle.Alignment:=tacenter;
 StringGrid_entree.Canvas.TextStyle := MyTextStyle;
 if isligne_intercalaire(arow) then
 begin
 StringGrid_entree.Canvas.Brush.Color :=clblue;

 exit; end;


 if isligne_mesurande(arow,i) then begin
 if (   (acol=0)) then  StringGrid_entree.Canvas.Brush.Color :=cl3dlight else
 if ((acol=5) ) then StringGrid_entree.Canvas.Brush.Color :=clmoneygreen;
 if (acol=0) then begin
 StringGrid_entree.Canvas.font.Color:=clblue;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];

 end;
 if (acol=1) then begin
 StringGrid_entree.Canvas.font.Color:=clgreen;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];

 end;
 if ((acol>1) and (acol<5)) then begin
  StringGrid_entree.Canvas.Brush.Style:= bsFDiagonal;
  StringGrid_entree.Canvas.Brush.Color :=clblack;
  setbkcolor(StringGrid_entree.Canvas.Handle,clwhite);
  end;

  exit;
       end;

 if isligne_distribution(arow,i,j) then begin
 if ((acol=2) or (acol=3))  then  StringGrid_entree.Canvas.Brush.Color :=cl3dlight else
  if acol=5 then StringGrid_entree.Canvas.Brush.Color :=clmoneygreen;
 if (acol=2) then begin
 StringGrid_entree.Canvas.font.Color:=clred;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];

 end;
 if (acol=4) then begin
 StringGrid_entree.Canvas.font.Color:=clgreen;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];

 end;
  if (acol<2) then begin
  StringGrid_entree.Canvas.Brush.Style:= bsFDiagonal;
  StringGrid_entree.Canvas.Brush.Color :=clblack;
  setbkcolor(StringGrid_entree.Canvas.Handle,clwhite);
  end;

 exit;
 end;




end;










procedure TForm1.TabSheet_entreeShow(Sender: TObject);
begin





  if not (expression_validee) then pagecontrol1.ActivePage:=tabsheet_expression;
end;

procedure TForm1.TabSheet_expressionShow(Sender: TObject);
begin





  edit_saisie_expression.SetFocus;
  edit_saisie_expression.SelStart := Length(edit_saisie_expression.Text);

end;

procedure TForm1.TabSheet_mcShow(Sender: TObject);
begin






   if not(expression_validee) then begin
  pagecontrol1.ActivePage:=tabsheet_expression;
  exit
  end;
   if not(tous_calculs_faits) then begin
  pagecontrol1.ActivePage:=tabsheet_entree;
  exit
  end;
end;

procedure TForm1.TabSheet_resultatsShow(Sender: TObject);
begin






  if not(expression_validee) then begin
  pagecontrol1.ActivePage:=tabsheet_expression;
  exit
  end;
   if not(tous_calculs_faits) then begin
  pagecontrol1.ActivePage:=tabsheet_entree;
  exit
  end;
end;



procedure TForm1.BitBtn1_Click(Sender: TObject);
var i,j,kkk,k:longint;   Vars    : Array OF ArbFloat;  toutes_variables_traitees:boolean;

 incertitude_relative:extended;


begin
      if nombre_mesurandes=0
    then begin
  application.MessageBox(pchar(rsIlNYAAucuneV), pchar(rsAttention), mb_ok);
  exit;
  end;

    if nombre_distributions=0
    then begin
  application.MessageBox(pchar(rsAucuneIncert), pchar(rsAttention), mb_ok);
  exit;
  end;









  toutes_variables_traitees:=true;
 for i:=1 to nombre_distributions do
 toutes_variables_traitees:=toutes_variables_traitees and not(myisnan(liste_distributions[i-1].incertitude_type));
  for i:=1 to nombre_mesurandes do
 toutes_variables_traitees:=toutes_variables_traitees and not(myisnan(liste_mesurandes[i-1].estimateur));
  if not(toutes_variables_traitees) then begin
  application.MessageBox(pchar(rsIlYADesVaria), pchar(rsAttention), mb_ok);
  exit;
  end;


  setlength(vars,nombre_mesurandes);
  Eval_f:=TEvaluator.Create(Liste_Variables,expr_temp);
   for j:=1 to nombre_mesurandes do
   vars[j-1]:=liste_mesurandes[j-1].estimateur;
   try
   estimateur_sortie:=Eval_f.Evaluate(Vars);
   except
   estimateur_sortie:=NAN;
   application.MessageBox(pchar(rsValeurDeSort), pchar(rsAttention2), mb_ok);
   exit;
     end;

    screen.Cursor:=crhourglass;
   setlength(eval_derivees,nombre_mesurandes);
          setlength(expr_derivees,nombre_mesurandes);
         setlength(valeur_derivees,nombre_mesurandes);

      for j:=1 to nombre_mesurandes do  begin
      expr_derivees[j-1]:=expr_temp.derive(Liste_Variables[j-1]);
      eval_derivees[j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees[j-1]);
      try
            valeur_derivees[j-1]:=eval_derivees[j-1].Evaluate(Vars);
            except
              valeur_derivees[j-1]:=NAN;
              end;

            end;

    setlength(eval_derivees_secondes,nombre_mesurandes,nombre_mesurandes);
          setlength(expr_derivees_secondes,nombre_mesurandes,nombre_mesurandes);
         setlength(valeur_derivees_secondes,nombre_mesurandes,nombre_mesurandes);

     setlength(eval_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);
          setlength(expr_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);
         setlength(valeur_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);

         setlength(contributions_croisees,nombre_distributions,nombre_distributions);


         for i:=1 to nombre_mesurandes do
         for j:=1 to nombre_mesurandes do begin
         expr_derivees_secondes[i-1,j-1]:=expr_derivees[i-1].Derive(Liste_Variables[j-1]);
         eval_derivees_secondes[i-1,j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees_secondes[i-1,j-1]);
      try
            valeur_derivees_secondes[i-1,j-1]:=eval_derivees_secondes[i-1,j-1].Evaluate(Vars);
            except
              valeur_derivees_secondes[i-1,j-1]:=NAN;
              end;

            end;

       for i:=1 to nombre_mesurandes do
         for j:=1 to nombre_mesurandes do begin
         expr_derivees_troisiemes[i-1,j-1]:=expr_derivees_secondes[j-1,j-1].Derive(Liste_Variables[i-1]);
         eval_derivees_troisiemes[i-1,j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees_troisiemes[i-1,j-1]);
      try
            valeur_derivees_troisiemes[i-1,j-1]:=eval_derivees_troisiemes[i-1,j-1].Evaluate(Vars);
            except
              valeur_derivees_troisiemes[i-1,j-1]:=NAN;
              end;

            end;
       for i:=1 to nombre_distributions do
       for j:=1 to nombre_distributions do

       begin
       try
      contributions_croisees[i-1,j-1]:=(  sqr(valeur_derivees_secondes[liste_distributions[i-1].indice_de_la_variable_correspondante,
      liste_distributions[j-1].indice_de_la_variable_correspondante])/2+
       valeur_derivees[liste_distributions[i-1].indice_de_la_variable_correspondante]*valeur_derivees_troisiemes[liste_distributions[i-1].indice_de_la_variable_correspondante
       ,liste_distributions[j-1].indice_de_la_variable_correspondante])*sqr(liste_distributions[i-1].incertitude_type*
       liste_distributions[j-1].incertitude_type);
          except
       contributions_croisees[i-1,j-1]:=nan;
          end;

       end;
      stringgrid1.RowCount:=1+nombre_distributions;
      stringgrid1.Cells[0,0]:='xij';
     // stringgrid1.Cells[1,0]:='ci';

     // stringgrid1.Cells[2,0]:='u(xij)';
     // stringgrid1.Cells[3, 0]:=rsContribution;
      stringgrid1.Cells[1, 0]:=rsContribution2;


     for j:=1 to nombre_mesurandes do begin
     liste_mesurandes[j-1].incertitude_type:=0;
     if  liste_mesurandes[j-1].nombre_erreurs>0 then
     for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
     liste_mesurandes[j-1].incertitude_type:=liste_mesurandes[j-1].incertitude_type+sqr(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type);
     liste_mesurandes[j-1].incertitude_type:=sqrt(liste_mesurandes[j-1].incertitude_type);
     end;


  incertitude_type_sortie:=0;
  try
  for j:=1 to nombre_mesurandes do
  if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
  incertitude_type_sortie:=incertitude_type_sortie+sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type);
   incertitude_type_sortie:=sqrt(incertitude_type_sortie);
     except
      incertitude_type_sortie:=nan;
     end;

      With Chart1 Do
Begin
Title.text.Clear;
Title.Text.Add(rsContribution3);
Title.visible := True;
Legend.Visible:= True;
end;

        With Chart2 Do
Begin
Title.text.Clear;
Title.Text.Add(rsContribution3);
Title.visible := True;
Legend.Visible:= True;
end;

     ListChartSource1.clear;

      kkk:=0;
   for j:=1 to nombre_mesurandes do  begin
    if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do  begin
  inc(kkk);
  stringgrid1.Cells[0,kkk]:=liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].nom_variable;
  {           stringgrid1.Cells[1,kkk]:=( Donne_Avec_Chiffres_Significatifs(valeur_derivees[j-1],3));

          stringgrid1.Cells[2,kkk]:=(Donne_Avec_Chiffres_Significatifs(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type,3));
  stringgrid1.Cells[3,kkk]:=Donne_Avec_Chiffres_Significatifs(sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type),3);  }
  stringgrid1.Cells[1,kkk]:=Donne_Avec_Chiffres_Significatifs(sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type)/
  sqr(incertitude_type_sortie)*100,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' %';
  ListChartSource1.Add({liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]+1}kkk,
  sqr(valeur_derivees[j-1]*liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type)/
  sqr(incertitude_type_sortie)*100,liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].nom_variable,rgb(random(255),random(255),random(255)));


  end;

   end;
   stringgrid1.AutoSizeColumns;


   label_estimateur_mesurande.Caption:=Format(rsEstimationMe, [
     Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie,
   incertitude_type_sortie, 2,
     option_tronque_a_zero_quand_incertitude_trop_grande,
     option_arrondi_superieur_incertitude, mon_genre_affichage_incertitude,
   ma_longueur_chaine_agreable_incertitude), symbole_unite]);
   label_estimateur_incertitude.Caption:=Format(rsEstimationIn, [
     Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie, 2,
     mon_genre_affichage_valeur_individuelle,
     ma_longueur_chaine_agreable_valeur_individuelle), symbole_unite]);


    if estimateur_sortie<>0 then incertitude_relative:=incertitude_type_sortie/estimateur_sortie*100 else
      incertitude_relative:=NAN;
    label_incertitude_relative.Caption:=Format(rsIncertitudeR, [
      Donne_Avec_Chiffres_Significatifs(incertitude_relative, 3,
      mon_genre_affichage_valeur_individuelle,
      ma_longueur_chaine_agreable_valeur_individuelle)])+'%';



      {gum ordre 2}


      incertitude_type_sortie:=sqr(incertitude_type_sortie);




      incertitude_type_sortie:=sqrt(incertitude_type_sortie);

    if estimateur_sortie<>0 then incertitude_relative:=incertitude_type_sortie/estimateur_sortie else
      incertitude_relative:=NAN;


  {fin gum ordre 2}




  {calcul degre liberte effectif global}
  degre_effectif_global:=0;
  for j:=1 to nombre_mesurandes do
  if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
  if (
  not(myisnan(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif))
  and
    not(myisnan(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type))
    and
   not(myisnan(valeur_derivees[j-1]) )
  and
  (liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif<>0)
  )

  then
  degre_effectif_global:=degre_effectif_global+sqr(sqr(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type*
  valeur_derivees[j-1]))/
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif;
 if degre_effectif_global<>0 then  degre_effectif_global:=sqr(sqr(incertitude_type_sortie))/degre_effectif_global;





   coef_elarg_95_normale:=1.959963985;
   coef_elarg_99_normale:=2.575829304;
   coef_elarg_75_normale:=1.150349380;




        if ((degre_effectif_global>0) and (degre_effectif_global<1000)) then begin
        try
       coef_elarg_95_student:=abs(t_invx(floor(degre_effectif_global),(1-0.95)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.95)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.95)/2))
       );
       except
        coef_elarg_95_student:=NAN;

       end;

       try
       coef_elarg_99_student:=
       abs(t_invx(floor(degre_effectif_global),(1-0.99)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.99)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.99)/2))
       );
       except
        coef_elarg_99_student:=NAN;
         end;
        try
        coef_elarg_75_student:= abs(t_invx(floor(degre_effectif_global),(1-0.75)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.75)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.75)/2))
       );
        except
         coef_elarg_75_student:=NAN;
        end;
        end else begin
        coef_elarg_95_student:=1.959963985;
   coef_elarg_99_student:=2.575829304;
   coef_elarg_75_student:=1.150349380;

        end;

 //si il y a une seule distribution et qu'elle est rectangulaire,
 //il faut prendre les coef correspondants !
    if (nombre_mesurandes=1) and   (liste_mesurandes[0].nombre_erreurs=1)
    and  (liste_distributions[liste_mesurandes[0].liste_des_indices_des_sources_derreur[0]].tyty=d_rectangle)
    then begin
    coef_elarg_95_student:=0.95*sqrt(3);
   coef_elarg_99_student:=0.99*sqrt(3);
   coef_elarg_75_student:=0.75*sqrt(3);

    end;

       stringgrid4.ColCount:=6;

  stringgrid4.RowCount:=4;
    stringgrid4.Cells[0, 0]:=rsTauxDeConfia;
     stringgrid4.Cells[1, 0]:=rsFacteurDLarg2;
      stringgrid4.Cells[2, 0]:=rsIncertitudeL;
    stringgrid4.Cells[3, 0]:=rsIntervalleYU;
       stringgrid4.Cells[4, 0]:=rsEcritureFina;
      stringgrid4.Cells[5, 0]:=rsEcritureFina2;
    stringgrid4.Cells[0,1]:='75%';
    stringgrid4.Cells[1,1]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_75_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,1]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_75_student,
    incertitude_type_sortie*coef_elarg_75_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_75_student,
    incertitude_type_sortie*coef_elarg_75_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,1]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_75_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
    stringgrid4.Cells[4,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
      stringgrid4.Cells[0,2]:='95%';
      stringgrid4.Cells[1,2]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_95_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,2]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_95_student,
     incertitude_type_sortie*coef_elarg_95_student, 3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_95_student,
      incertitude_type_sortie*coef_elarg_95_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,2]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_95_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
    stringgrid4.Cells[4,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
     stringgrid4.Cells[0,3]:='99%';
     stringgrid4.Cells[1,3]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_99_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,3]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_99_student,
       incertitude_type_sortie*coef_elarg_99_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_99_student,
     incertitude_type_sortie*coef_elarg_99_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,3]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_99_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid4.Cells[4,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
       stringgrid4.AutoSizeColumns;





      Actualise_Ecart_Relatif_A_Valeur_Reference(Sender);

   tous_calculs_faits:=true;
    pagecontrol1.ActivePage:=TabSheet_resultats;




    screen.Cursor:=crdefault;
end;

procedure TForm1.BitBtn_charger_depuis_autreClick(Sender: TObject);
begin
   Form1.MenuItem_ouvrir_dernierClick(Sender);
end;

procedure TForm1.BitBtn_charger_depuis_exemplesClick(Sender: TObject);
begin
  Form1.MenuItem_ouvrir_exemplesClick(Sender);
end;

procedure TForm1.BitBtn_charger_depuis_personnelClick(Sender: TObject);
begin
   Form1.MenuItem_ouvrir_personnelClick(Sender);
end;



procedure TForm1.MenuItem11Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem_affichage_incertitudeClick(Sender: TObject);
begin
  with Form_affichage_incertitude do begin
  case  mon_genre_affichage_incertitude of
  sans_point_decimal:RadioGroup1.itemindex:=0;
 sans_puissance_de_dix:RadioGroup1.itemindex:=1;
  avec_un_chiffre_avant_virgule_pour_valeur:RadioGroup1.itemindex:=2 ;
  avec_un_chiffre_avant_virgule_pour_incertitude:RadioGroup1.itemindex:=3 ;
  end;
  spinedit1.value:= ma_longueur_chaine_agreable_incertitude;
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  Showmodal;
 end;

end;

procedure TForm1.MenuItem_affichage_individuelClick(Sender: TObject);
begin
   with Form_affichage_valeur_individuelle do begin
  case  mon_genre_affichage_valeur_individuelle of
  _sans_point_decimal:RadioGroup1.itemindex:=1;
  _sans_puissance_de_dix:RadioGroup1.itemindex:=2;
   _avec_un_chiffre_avant_virgule:RadioGroup1.itemindex:=0 ;
  end;
  spinedit1.value:= ma_longueur_chaine_agreable_valeur_individuelle;
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  Showmodal;
end;   end;

procedure TForm1.BitBtn10Click(Sender: TObject);
begin
  pagecontrol1.ActivePage:=tabsheet_expression;
end;














procedure TForm1.BitBtn_fonction_Click(Sender: TObject);
  var i:integer;

  begin

            symbole_grandeur_sortie:=edit_nom_grandeur_sortie.Text;
            symbole_unite:=edit_saisie_unite.Text;
            if   symbole_unite='' then symbole_unite:=rsUnit;
            if  symbole_grandeur_sortie='' then symbole_grandeur_sortie:='Y';
        chaine_expr:=Edit_saisie_expression.Text;

 if chaine_expr='' then begin
   application.MessageBox(pchar(rsVousNAvezPas), pchar(rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
          end;


        if chaine_expr=old_chaine_expr then begin
        pagecontrol1.ActivePage:=tabsheet_entree;
        exit;
                end;
        try
         Expr_temp:=TExpression.Create(chaine_expr);

        except

          application.MessageBox(pchar(rsErreurDeSynt),pchar( rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
          end;




        if  Expr_temp.SymbolicValueNames.Count=0 then begin
         application.MessageBox(pchar(rsAucunMesurande), pchar(rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
        end;







       expression_validee:=true;
       old_chaine_expr:=chaine_expr;



        Liste_Variables:=Expr_temp.SymbolicValueNames;
    nombre_mesurandes:=Liste_Variables.Count;






       setlength(liste_distributions,0);
       nombre_distributions:=0;


    setlength(liste_mesurandes,nombre_mesurandes);
      for i:=1 to nombre_mesurandes do  begin
      liste_mesurandes[i-1].nom_mesurande:=liste_variables[i-1];
      liste_mesurandes[i-1].estimateur:=0;
      liste_mesurandes[i-1].nombre_erreurs:=0;
      setlength(liste_mesurandes[i-1].liste_des_indices_des_sources_derreur,0);


      end;
    setlength(liste_distribution_est_traitee,nombre_mesurandes);

     Form1.rafraichitstringgridentree(sender);
        tous_calculs_faits:=false;



     Initialise_Generateur(0);



 if expression_validee then
  pagecontrol1.ActivePage:=tabsheet_entree;
end;

procedure TForm1.Edit_saisie_expressionChange(Sender: TObject);
begin
  if  Form1.Edit_saisie_expression.text<>chaine_expr then begin
  expression_validee:=false;
  tous_calculs_faits:=false;

  end;
end;





procedure TForm1.FormCreate(Sender: TObject);
 var newmenuitem:tmenuitem;
S:sysutils.TSearchRec;   il:integer;
  begin
   encreation:=true;
   radiogroup1.Caption:=rsDiagramme;
   radiogroup1.Items.Clear;
   radiogroup1.Items.Add(rsBarres);
   radiogroup1.Items.Add(rsCamembert);
   radiogroup1.ItemIndex:=0;


  speedbutton1.Hint:=rsCopierDansLe;

        LABEL9.CAPTION:=rsIntervallesD2;

        TabSheetComparaison.Caption:=rsComparaisonU;



  StaticText_facultatif.Caption:=rsCetOngletEst;
  StaticText_valeur_reference.Caption:=rsValeurDeRFRe2;
    StaticText_valeur_mesure.Caption:=rsValeurMesurE;
         StaticText_incertitude_type.Caption:=rsIncertitudeT3;

      BitBtn_comparer_reference.Caption:=rsComparer;
  StaticText_diff_mes_ref.caption:=rsYmesureYrefe;




   CAPTION:=rsGum_MCLogici2;
   tabsheet_commentaires.Caption:=rsCommentaires2;
TABSHEET_BIENVENUE.CAPTION:=rsBienvenue;
STATICTEXT1.CAPTION:=rsBienvenueDan;
STATICTEXT2.CAPTION:=rsLeButDeCeLog;
STATICTEXT3.CAPTION:=rsVousDevezDAb;


STATICTEXT5.CAPTION:=rsRemarques1Le;

  BitBtn_charger_depuis_exemples.Caption:=rsChargerLeFic;
    BitBtn_charger_depuis_personnel.Caption:=rsChargerLeFic2;
          BitBtn_charger_depuis_autre.Caption:=rsChargerLeFic3;






TABSHEET_EXPRESSION.CAPTION:=rsExpressionDe;
BITBTN_FONCTION_.CAPTION:=rsValiderEtPas_1+lineending+rsValiderEtPas_2+lineending+rsValiderEtPas_3+lineending+
rsValiderEtPas_4+lineending+rsValiderEtPas_5+lineending+rsValiderEtPas_6;
EDIT_SAISIE_EXPRESSION.HINT:=rsSaisissezIci;
EDIT_NOM_GRANDEUR_SORTIE.HINT:=rsSymboleGrand;
EDIT_NOM_GRANDEUR_SORTIE.TEXT:=rsY;
STATICTEXT6.CAPTION:=rsSymboleGrand2;
STATICTEXT7.CAPTION:=rsExpressionEn;

EDIT_SAISIE_UNITE.HINT:=rsSymboleUnit;
EDIT_SAISIE_UNITE.TEXT:=rsUnit;
STATICTEXT10.CAPTION:=rsSymboleDeLUn;
TABSHEET_ENTREE.CAPTION:=rsGrandeursDEn;
BITBTN1_.CAPTION:=rsValiderEtCal_1+lineending+rsValiderEtCal_2+lineending+rsValiderEtCal_3+lineending+
rsValiderEtCal_4+lineending+rsValiderEtCal_5+lineending+rsValiderEtCal_6+lineending+rsValiderEtCal_7;
STRINGGRID_ENTREE.HINT:=rsCliquezSurLa;
TABSHEET_RESULTATS.CAPTION:=rsRSultatsParP;





MENUITEM1.CAPTION:=rsOptions;

//MENUITEM_MONTECARLO.CAPTION:=rsMonteCarlo;
MENUITEM_INCERTITUDE.CAPTION:=rsEnCasDIncert;
MENUITEM_ARRONDI_INC.CAPTION:=rsArrondiSurLI;
MENUITEM_ARRONDI_SUP_INC.CAPTION:=rsSupRieurDFau;
MENUITEM_ARRONDI_NORMAL_INC.CAPTION:=rsNormal;
MENUITEM9.CAPTION:=rsLangue;
MENUITEM2.CAPTION:=rsAide;
MENUITEM4.CAPTION:=rs3;
MENUITEM3.CAPTION:=rsLicenceGPL;
MENUITEM7.CAPTION:=rs3;
MENUITEM8.CAPTION:=rsSiteWeb;
MENUITEM6.CAPTION:=rs3;
MENUITEM5.CAPTION:=rsAPropos;







   expression_validee:=false;
  nombre_mesurandes:=0;

   if liste_langues.Count>0 then
            for il:=1 to  liste_langues.Count do begin
            newmenuitem:=tmenuitem.Create(mainmenu1);
            newmenuitem.Caption:=liste_langues[il-1];
            newmenuitem.Tag:=1000+il;
            newmenuitem.OnClick:=@menuitem9click;
            if  liste_langues[il-1]=fallbacklang then newmenuitem.Checked:=true;
            menuitem9.add(newmenuitem);
            end;








    pagecontrol1.ActivePage:=tabsheet_bienvenue;

    with Form1 do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
end;

initialization
  {$I unit1.lrs}
   mon_genre_affichage_incertitude:=sans_puissance_de_dix;
   mon_genre_affichage_valeur_individuelle:=_sans_puissance_de_dix;
   ma_longueur_chaine_agreable_valeur_individuelle:=10;
  ma_longueur_chaine_agreable_incertitude:=20;
  chaine_expr:='';  old_chaine_expr:='';
  nombre_mesurandes:=0;    nombre_distributions:=0;
  setlength(liste_distribution_est_traitee,0);
  setlength(liste_mesurandes,0);
   setlength(liste_distributions,0);
   expression_validee:=false;    tous_calculs_faits:=false;
 {$ifndef darwin}  application.UpdateFormatSettings:=false;   {$endif}
  DefaultFormatSettings.DecimalSeparator:='.';

  puissance_de_nombre_par_echantillon:=6;
    nombre_par_echantillon:=1000000;
    nombre_de_classes:=500;   valeur_reference:=0; comparaison_relative:=0;
    Initialise_Generateur(0);
    repertoireexecutable:=extractfilepath(Application.ExeName);
    option_tronque_a_zero_quand_incertitude_trop_grande:=true;
    option_arrondi_superieur_incertitude:=true;
chance_que_lecart_soit_superieur_normal:=0; chance_que_lecart_soit_superieur_student:=0;
    repertoire_executable:=AppendPathDelim(extractfilepath(systoutf8(Application.ExeName)));
    repertoire_images:=AppendPathDelim(repertoire_executable+'images');
     nomexecutable:=extractfilename(Application.ExeName);
         repertoire_exemples:=AppendPathDelim(repertoire_executable+'exemples');
         repertoire_aide:=AppendPathDelim(repertoire_executable+'aide');
          repertoire_config_perso:=AppendPathDelim(MyGetAppConfigDirUTF8);

          {$ifdef windows}
  repertoire_propagation_perso:=AppendPathDelim(AppendPathDelim(MyGetMesDocumentsUTF8)+'MesCalculsDIncertitude');
   {$endif}
   {$ifndef windows}
    repertoire_propagation_perso:=AppendPathDelim({repertoire_config_perso}getuserdir+'MesCalculsDIncertitude');
     {$endif}


     dernier_repertoire_utilise_chargement:=repertoire_exemples;
     dernier_repertoire_utilise_sauvegarde:=repertoire_propagation_perso;
     nom_fichier_sauvegarde:='';
     nom_fichier_chargement:='';

     if not(directoryexistsUTF8(repertoire_config_perso)) then   try
    forcedirectories(UTF8ToSys(repertoire_config_perso));
   except; end;
      if not(directoryexistsUTF8(repertoire_propagation_perso)) then   try
    forcedirectories(UTF8ToSys(repertoire_propagation_perso));
   except; end;

liste_langues:=tstringlist.create;
       chemin_po:=AppendPathDelim(repertoire_executable+'lang');

        If FindFirstutf8(Chemin_po+'gum_mc.*.po',faAnyFile,Search)=0
Then Begin
 Repeat
    if (Search.Name='.') or (Search.Name='..') or (Search.Name='')
      then continue;
            { liste_langues.Add(copy(Search.name,length(Search.name)-4,2)); }
            ID_lang:=copy(Search.name,length('gum_mc.')+1,
               length(Search.Name)-length('gum_mc..po'));
            if (ID_lang<>'') and (Pos('.',ID_lang)<1) and (liste_langues.IndexOf(ID_lang)<0)
    then liste_langues.Add(ID_lang);
            Until FindNextutf8(Search)<>0;
 FindCloseutf8(Search);
End;


    lang:='';  FallbackLang:='';

  nom_ini_file:=repertoire_config_perso+'gum_mc.ini';
   if not(fileexistsutf8(nom_ini_file)) then begin
     GetLanguageIDs(lang,FallbackLang);
           if ((liste_langues.indexof(uppercase(lang))=-1) and
          (liste_langues.indexof(uppercase(FallbackLang))=-1)) then
        begin
      Lang:='fr_FR';  FallbackLang:='fr';
             end;
     goto 1888;
     end;
      assignfile(f_ini,UTF8ToSys(nom_ini_file));
     reset(f_ini);
     readln(f_ini,lang);
            readln(f_ini,FallbackLang);
     closefile(f_ini);


    //GetLanguageIDs(Lang, FallbackLang); // dans l'unité gettext



    1888:
PODirectory:=IncludeTrailingPathDelimiter(
                      IncludeTrailingPathDelimiter(
                       ExtractFilePath(Application.ExeName))+'lang');
    TranslateUnitResourceStrings('LCLStrConsts', PODirectory + 'lclstrconsts.%s.po', Lang, FallbackLang);
    TranslateUnitResourceStrings('UChaines', PODirectory + 'gum_mc.%s.po', Lang, FallbackLang);
  parametre_ligne_commande:=paramcount>=1;

end.

